Loading...
Searching...
No Matches
osmo_ss7.h File Reference
`#include <stdint.h>`
`#include <stdbool.h>`
`#include <osmocom/core/linuxlist.h>`
`#include <osmocom/core/utils.h>`
`#include <osmocom/core/fsm.h>`
`#include <osmocom/core/msgb.h>`
`#include <osmocom/core/prim.h>`
`#include <osmocom/core/socket.h>`
`#include <osmocom/core/rate_ctr.h>`

Go to the source code of this file.

## Data Structures

struct | osmo_ss7_routing_key

## Macros

#define | OSMO_SS7_PC_INVALID 0xffffffff
#define | OSMO_SS7_ASP_QUIRK_NO_NOTIFY 0x00000001
| Peer SG doesn't send NTFY(AS-INACTIVE) after ASP-UP procedure.
#define | OSMO_SS7_ASP_QUIRK_DAUD_IN_ASP 0x00000002
| Accept DAUD in ASP role (RFC states only permitted in ASP->SG role).
#define | OSMO_SS7_ASP_QUIRK_SNM_INACTIVE 0x00000004
| Accept SSNM even if ASP is in AS-INACTIVE state.

## Typedefs

typedef int | osmo_ss7_asp_rx_unknown_cb(struct osmo_ss7_asp *asp, int ppid_mux, struct msgb *msg)
| Weak function to handle payload for unknown/unsupported PPID or IPA StreamID.

## Enumerations

enum | osmo_ss7_asp_protocol { OSMO_SS7_ASP_PROT_NONE , OSMO_SS7_ASP_PROT_SUA , OSMO_SS7_ASP_PROT_M3UA , OSMO_SS7_ASP_PROT_IPA , _NUM_OSMO_SS7_ASP_PROT }
enum | osmo_ss7_as_traffic_mode { OSMO_SS7_AS_TMOD_OVERRIDE = 0 , OSMO_SS7_AS_TMOD_BCAST , OSMO_SS7_AS_TMOD_LOADSHARE , OSMO_SS7_AS_TMOD_ROUNDROBIN , _NUM_OSMO_SS7_ASP_TMOD }
enum | osmo_ss7_asp_admin_state { OSMO_SS7_ASP_ADM_S_SHUTDOWN , OSMO_SS7_ASP_ADM_S_BLOCKED , OSMO_SS7_ASP_ADM_S_ENABLED }
enum | osmo_ss7_asp_role { OSMO_SS7_ASP_ROLE_ASP , OSMO_SS7_ASP_ROLE_SG , OSMO_SS7_ASP_ROLE_IPSP }

## Functions

struct osmo_ss7_instance * | osmo_ss7_instances_llist_entry (struct llist_head *list)
int | osmo_ss7_init (void)
static bool | osmo_ss7_pc_is_valid (uint32_t pc)
struct osmo_ss7_instance * | osmo_ss7_instance_find (uint32_t id)
| Find a SS7 Instance with given ID.
struct osmo_ss7_instance * | osmo_ss7_instance_find_or_create (void *ctx, uint32_t id)
| Find or create a SS7 Instance.
void | osmo_ss7_instance_destroy (struct osmo_ss7_instance *inst)
| Destroy a SS7 Instance.
uint32_t | osmo_ss7_instance_get_id (const struct osmo_ss7_instance *inst)
const char * | osmo_ss7_instance_get_name (const struct osmo_ss7_instance *inst)
int | osmo_ss7_instance_set_pc_fmt (struct osmo_ss7_instance *inst, uint8_t c0, uint8_t c1, uint8_t c2)
| Set the point code format used in given SS7 instance.
const struct osmo_ss7_pc_fmt * | osmo_ss7_instance_get_pc_fmt (const struct osmo_ss7_instance *inst)
uint32_t | osmo_ss7_instance_get_primary_pc (const struct osmo_ss7_instance *inst)
struct osmo_sccp_instance * | osmo_ss7_ensure_sccp (struct osmo_ss7_instance *inst)
| Allocate an SCCP instance, if not present yet.
struct osmo_sccp_instance * | osmo_ss7_get_sccp (const struct osmo_ss7_instance *inst)
| Get the SCCP instance, if present.
int | osmo_ss7_find_free_rctx (struct osmo_ss7_instance *inst)
bool | osmo_ss7_pc_is_local (const struct osmo_ss7_instance *inst, uint32_t pc)
int | osmo_ss7_pointcode_parse (const struct osmo_ss7_instance *inst, const char *str)
int | osmo_ss7_pointcode_parse_mask_or_len (const struct osmo_ss7_instance *inst, const char *in)
const char * | osmo_ss7_pointcode_print_buf (char *buf, size_t buf_len, const struct osmo_ss7_instance *inst, uint32_t pc)
const char * | osmo_ss7_pointcode_print (const struct osmo_ss7_instance *inst, uint32_t pc)
const char * | osmo_ss7_pointcode_print2 (const struct osmo_ss7_instance *inst, uint32_t pc)
uint8_t | osmo_ss7_pc_width (const struct osmo_ss7_pc_fmt *pc_fmt)
uint32_t | osmo_ss7_pc_normalize (const struct osmo_ss7_pc_fmt *pc_fmt, uint32_t pc)
struct osmo_ss7_user * | osmo_ss7_user_create (struct osmo_ss7_instance *inst, const char *name)
void | osmo_ss7_user_destroy (struct osmo_ss7_user *user)
struct osmo_ss7_instance * | osmo_ss7_user_get_instance (const struct osmo_ss7_user *user)
void | osmo_ss7_user_set_prim_cb (struct osmo_ss7_user *user, osmo_prim_cb prim_cb)
void | osmo_ss7_user_set_priv (struct osmo_ss7_user *user, void *priv)
void * | osmo_ss7_user_get_priv (const struct osmo_ss7_user *user)
int | osmo_ss7_user_register (struct osmo_ss7_instance *inst, uint8_t service_ind, struct osmo_ss7_user *user)
| Register a MTP user for a given service indicator.
int | osmo_ss7_user_unregister (struct osmo_ss7_instance *inst, uint8_t service_ind, struct osmo_ss7_user *user)
| Unregister a MTP user for a given service indicator.
int | osmo_ss7_user_mtp_xfer_req (struct osmo_ss7_instance *inst, struct osmo_mtp_prim *omp)
void | osmo_sccp_set_max_optional_data (struct osmo_sccp_instance *inst, int val)
| Adjust the upper bound for the optional data length (the payload) for CR, CC, CREF and RLSD messages.
struct osmo_ss7_route * | osmo_ss7_route_lookup (struct osmo_ss7_instance *inst, uint32_t dpc)
| Find a SS7 route for given destination point code in given SS7.
const char * | osmo_ss7_route_print (const struct osmo_ss7_route *rt)
const char * | osmo_ss7_route_name (struct osmo_ss7_route *rt, bool list_asps)
| Return human readable representation of the route, in a static buffer.
struct osmo_ss7_as * | osmo_ss7_route_get_dest_as (struct osmo_ss7_route *rt)
| Get destination AS of route.
static const char * | osmo_ss7_asp_protocol_name (enum osmo_ss7_asp_protocol mode)
int | osmo_ss7_asp_protocol_port (enum osmo_ss7_asp_protocol prot)
static const char * | osmo_ss7_as_traffic_mode_name (enum osmo_ss7_as_traffic_mode mode)
enum osmo_ss7_as_traffic_mode | osmo_ss7_tmode_from_xua (uint32_t in)
int | osmo_ss7_tmode_to_xua (enum osmo_ss7_as_traffic_mode tmod)
struct osmo_ss7_as * | osmo_ss7_as_find_by_name (struct osmo_ss7_instance *inst, const char *name)
| Find Application Server by given name.
struct osmo_ss7_as * | osmo_ss7_as_find_by_rctx (struct osmo_ss7_instance *inst, uint32_t rctx)
| Find Application Server by given routing context.
struct osmo_ss7_as * | osmo_ss7_as_find_by_l_rk_id (struct osmo_ss7_instance *inst, uint32_t l_rk_id)
| Find Application Server by given local routing key ID.
struct osmo_ss7_as * | osmo_ss7_as_find_by_proto (struct osmo_ss7_instance *inst, enum osmo_ss7_asp_protocol proto)
| Find Application Server (AS) by given protocol.
struct osmo_ss7_as * | osmo_ss7_as_find_or_create (struct osmo_ss7_instance *inst, const char *name, enum osmo_ss7_asp_protocol proto)
| Find or Create Application Server.
enum osmo_ss7_asp_protocol | osmo_ss7_as_get_asp_protocol (const struct osmo_ss7_as *as)
| Get asp_protocol configuration of a given AS.
int | osmo_ss7_as_add_asp (struct osmo_ss7_as *as, const char *asp_name)
| Add given ASP to given AS.
int | osmo_ss7_as_del_asp (struct osmo_ss7_as *as, const char *asp_name)
| Delete given ASP from given AS.
void | osmo_ss7_as_destroy (struct osmo_ss7_as *as)
| Destroy given Application Server.
bool | osmo_ss7_as_has_asp (const struct osmo_ss7_as *as, const struct osmo_ss7_asp *asp)
| Determine if given AS contains ASP.
struct osmo_ss7_asp * | osmo_ss7_as_select_asp (struct osmo_ss7_as *as)
| Select an AS to transmit a message, according to AS configuration and ASP availability.
bool | osmo_ss7_as_down (const struct osmo_ss7_as *as)
| Determine if given AS is in the down state.
bool | osmo_ss7_as_active (const struct osmo_ss7_as *as)
| Determine if given AS is in the active state.
bool | osmo_ss7_as_tmode_compatible_xua (struct osmo_ss7_as *as, uint32_t m3ua_tmt)
struct osmo_ss7_asp * | osmo_ss7_asp_find_by_name (struct osmo_ss7_instance *inst, const char *name)
struct osmo_ss7_asp * | osmo_ss7_asp_find_by_proto (struct osmo_ss7_as *as, enum osmo_ss7_asp_protocol proto)
| Find an ASP that matches the given ASP protocol (xUA variant).
struct osmo_ss7_asp * | osmo_ss7_asp_find (struct osmo_ss7_instance *inst, const char *name, uint16_t remote_port, uint16_t local_port, enum osmo_ss7_asp_protocol proto) OSMO_DEPRECATED("Use osmo_ss7_asp_find2() instead")
struct osmo_ss7_asp * | osmo_ss7_asp_find2 (struct osmo_ss7_instance *inst, const char *name, uint16_t remote_port, uint16_t local_port, int trans_proto, enum osmo_ss7_asp_protocol proto)
struct osmo_ss7_asp * | osmo_ss7_asp_find_or_create (struct osmo_ss7_instance *inst, const char *name, uint16_t remote_port, uint16_t local_port, enum osmo_ss7_asp_protocol proto) OSMO_DEPRECATED("Use osmo_ss7_asp_find_or_create2() instead")
struct osmo_ss7_asp * | osmo_ss7_asp_find_or_create2 (struct osmo_ss7_instance *inst, const char *name, uint16_t remote_port, uint16_t local_port, int trans_proto, enum osmo_ss7_asp_protocol proto)
void | osmo_ss7_asp_disconnect (struct osmo_ss7_asp *asp)
void | osmo_ss7_asp_destroy (struct osmo_ss7_asp *asp)
int | osmo_ss7_asp_send (struct osmo_ss7_asp *asp, struct msgb *msg)
| send a fully encoded msgb via a given ASP
int | osmo_ss7_asp_restart (struct osmo_ss7_asp *asp)
int | osmo_ss7_asp_use_default_lm (struct osmo_ss7_asp *asp, int log_level)
bool | osmo_ss7_asp_active (const struct osmo_ss7_asp *asp)
int | osmo_ss7_asp_get_log_subsys (const struct osmo_ss7_asp *asp)
| Get the logging subsystem for a given ASP.
const char * | osmo_ss7_asp_get_name (const struct osmo_ss7_asp *asp)
| Get the name of a given ASP.
enum osmo_ss7_asp_protocol | osmo_ss7_asp_get_proto (const struct osmo_ss7_asp *asp)
| Get the proto of a given ASP.
int | osmo_ss7_asp_get_trans_proto (const struct osmo_ss7_asp *asp)
| Get the transport proto of a given ASP.
void | osmo_ss7_register_rx_unknown_cb (osmo_ss7_asp_rx_unknown_cb *cb)
| Register a call-back function for unknown SCTP PPID / IPA Stream ID.
struct osmo_sccp_instance * | osmo_sccp_simple_client (void *ctx, const char *name, uint32_t default_pc, enum osmo_ss7_asp_protocol prot, int default_local_port, const char *default_local_ip, int default_remote_port, const char *default_remote_ip)
| request an sccp client instance
struct osmo_sccp_instance * | osmo_sccp_simple_client_on_ss7_id (void *ctx, uint32_t ss7_id, const char *name, uint32_t default_pc, enum osmo_ss7_asp_protocol prot, int default_local_port, const char *default_local_ip, int default_remote_port, const char *default_remote_ip)
| request an sccp client instance
struct osmo_sccp_instance * | osmo_sccp_simple_server (void *ctx, uint32_t pc, enum osmo_ss7_asp_protocol prot, int local_port, const char *local_ip)
struct osmo_sccp_instance * | osmo_sccp_simple_server_on_ss7_id (void *ctx, uint32_t ss7_id, uint32_t pc, enum osmo_ss7_asp_protocol prot, int local_port, const char *local_ip)
struct osmo_sccp_instance * | osmo_sccp_simple_server_add_clnt (struct osmo_sccp_instance *inst, enum osmo_ss7_asp_protocol prot, const char *name, uint32_t pc, int local_port, int remote_port, const char *remote_ip)
void | osmo_ss7_vty_init_asp (void *ctx)
void | osmo_ss7_vty_init_sg (void *ctx)
int | osmo_ss7_vty_go_parent (struct vty *vty)
int | osmo_ss7_is_config_node (struct vty *vty, int node)

## Variables

struct llist_head | osmo_ss7_instances
struct value_string | osmo_ss7_asp_protocol_vals []
struct value_string | osmo_ss7_as_traffic_mode_vals []
const struct value_string | osmo_ss7_asp_role_names []

## Macro Definition Documentation

## OSMO_SS7_ASP_QUIRK_DAUD_IN_ASP

#define OSMO_SS7_ASP_QUIRK_DAUD_IN_ASP 0x00000002

Accept DAUD in ASP role (RFC states only permitted in ASP->SG role).

Referenced by m3ua_rx_snm_asp(), and sua_rx_snm_asp().

## OSMO_SS7_ASP_QUIRK_NO_NOTIFY

#define OSMO_SS7_ASP_QUIRK_NO_NOTIFY 0x00000001

Peer SG doesn't send NTFY(AS-INACTIVE) after ASP-UP procedure.

Referenced by lm_timer_cb().

## OSMO_SS7_ASP_QUIRK_SNM_INACTIVE

#define OSMO_SS7_ASP_QUIRK_SNM_INACTIVE 0x00000004

Accept SSNM even if ASP is in AS-INACTIVE state.

Referenced by m3ua_rx_snm(), and sua_rx_snm().

## OSMO_SS7_PC_INVALID

#define OSMO_SS7_PC_INVALID 0xffffffff

Referenced by osmo_sccp_user_bind(), ss7_instance_alloc(), and vty_show_connection().

## Typedef Documentation

## osmo_ss7_asp_rx_unknown_cb

typedef int osmo_ss7_asp_rx_unknown_cb(struct osmo_ss7_asp *asp, int ppid_mux, struct msgb *msg)

Weak function to handle payload for unknown/unsupported PPID or IPA StreamID.

This function can be overridden by application code to implement whatever handling it wants for such additional payloads/streams.

Parameters

  [in] | asp | Application Server Process through which data was received
  [in] | ppid_sid | SCTP PPID (in sigtran case) or IPA Stream ID
  [in] | msg | Message buffer containing received data. Continues to be owned by caller!

Returns
  0 on success; negative on error

## Enumeration Type Documentation

## osmo_ss7_as_traffic_mode

enum osmo_ss7_as_traffic_mode

Enumerator
OSMO_SS7_AS_TMOD_OVERRIDE |
OSMO_SS7_AS_TMOD_BCAST |
OSMO_SS7_AS_TMOD_LOADSHARE |
OSMO_SS7_AS_TMOD_ROUNDROBIN |
_NUM_OSMO_SS7_ASP_TMOD |

## osmo_ss7_asp_admin_state

enum osmo_ss7_asp_admin_state

Enumerator
OSMO_SS7_ASP_ADM_S_SHUTDOWN | no SCTP association with peer
OSMO_SS7_ASP_ADM_S_BLOCKED | SCP association, but reject ASP-ACTIVE.
OSMO_SS7_ASP_ADM_S_ENABLED | in normal operation

## osmo_ss7_asp_protocol

enum osmo_ss7_asp_protocol

Enumerator
OSMO_SS7_ASP_PROT_NONE |
OSMO_SS7_ASP_PROT_SUA |
OSMO_SS7_ASP_PROT_M3UA |
OSMO_SS7_ASP_PROT_IPA |
_NUM_OSMO_SS7_ASP_PROT |

## osmo_ss7_asp_role

enum osmo_ss7_asp_role

Enumerator
OSMO_SS7_ASP_ROLE_ASP |
OSMO_SS7_ASP_ROLE_SG |
OSMO_SS7_ASP_ROLE_IPSP |

## Function Documentation

## osmo_sccp_set_max_optional_data()

void osmo_sccp_set_max_optional_data | ( | struct osmo_sccp_instance * | inst,
|  | int | val )

Adjust the upper bound for the optional data length (the payload) for CR, CC, CREF and RLSD messages.

For any Optional Data part larger than this value in octets, send CR, CC, CREF and RLSD messages without any payload, and send the data payload in a separate Data Form 1 message. ITU-T Q.713 sections 4.2 thru 4.5 define a limit of 130 bytes for the 'Data' parameter. This limit can be adjusted here. May be useful for interop with nonstandard SCCP peers.

Parameters

  [in] | sccp | SCCP instance to reconfigure.
  [in] | val | Number of bytes to set as upper bound for the optional data length, or pass a negative value to set the standard value of SCCP_MAX_OPTIONAL_DATA == 130, which conforms to ITU-T Q.713.

References osmo_xua_server::inst.

Referenced by DEFUN_ATTR().

## osmo_sccp_simple_client()

struct osmo_sccp_instance * osmo_sccp_simple_client | ( | void * | ctx,
|  | const char * | name,
|  | uint32_t | default_pc,
|  | enum osmo_ss7_asp_protocol | prot,
|  | int | default_local_port,
|  | const char * | default_local_ip,
|  | int | default_remote_port,
|  | const char * | default_remote_ip )

request an sccp client instance

Parameters

  [in] | ctx | talloc context
  [in] | name | human readable name
  [in] | default_pc | pointcode to be used on missing VTY setting
  [in] | prot | protocol to be used (e.g OSMO_SS7_ASP_PROT_M3UA)
  [in] | default_local_port | local port to be used on missing VTY setting
  [in] | default_local_ip | local IP-address to be used on missing VTY setting
  [in] | default_remote_port | remote port to be used on missing VTY setting
  [in] | default_remote_ip | remote IP-address to be used on missing VTY setting

Returns
  callee-allocated SCCP instance on success; NULL on error

This is simplified version of osmo_sccp_simple_client_on_ss7_id(). the only difference is that the ID of the CS7 instance will be set to 0 statically

References osmo_sccp_simple_client_on_ss7_id().

## osmo_sccp_simple_client_on_ss7_id()

struct osmo_sccp_instance * osmo_sccp_simple_client_on_ss7_id | ( | void * | ctx,
|  | uint32_t | ss7_id,
|  | const char * | name,
|  | uint32_t | default_pc,
|  | enum osmo_ss7_asp_protocol | prot,
|  | int | default_local_port,
|  | const char * | default_local_ip,
|  | int | default_remote_port,
|  | const char * | default_remote_ip )

request an sccp client instance

Parameters

  [in] | ctx | talloc context
  [in] | ss7_id | of the SS7/CS7 instance
  [in] | name | human readable name
  [in] | default_pc | pointcode to be used on missing VTY setting
  [in] | prot | protocol to be used (e.g OSMO_SS7_ASP_PROT_M3UA)
  [in] | default_local_port | local port to be used on missing VTY setting
  [in] | default_local_ip | local IP-address to be used on missing VTY setting (NULL: use library own defaults)
  [in] | default_remote_port | remote port to be used on missing VTY setting
  [in] | default_remote_ip | remote IP-address to be used on missing VTY setting (NULL: use library own defaults)

Returns
  callee-allocated SCCP instance on success; NULL on error

The function will examine the given CS7 instance and its sub components (as, asp, etc.). If necessary it will allocate the missing components. If no CS7 instance can be detected under the caller supplied ID, a new instance will be created beforehand.

References osmo_ss7_instance::as_list, osmo_ss7_instance::asp_list, osmo_ss7_as::cfg, osmo_ss7_asp::cfg, osmo_ss7_instance::cfg, osmo_ss7_instance::id, osmo_ss7_asp::is_server, osmo_ss7_as::list, osmo_ss7_asp::list, osmo_ss7_asp::local, osmo_ss7_as::name, osmo_ss7_asp::name, osmo_ss7_as_add_asp(), osmo_ss7_as_destroy(), osmo_ss7_as_find_by_proto(), osmo_ss7_as_find_or_create(), osmo_ss7_as_has_asp(), osmo_ss7_asp_destroy(), osmo_ss7_asp_find_by_proto(), osmo_ss7_asp_find_or_create2(), OSMO_SS7_ASP_PROT_IPA, osmo_ss7_asp_protocol_name(), osmo_ss7_asp_protocol_port(), osmo_ss7_asp_restart(), OSMO_SS7_ASP_ROLE_ASP, osmo_ss7_asp_use_default_lm(), osmo_ss7_ensure_sccp(), osmo_ss7_instance_destroy(), osmo_ss7_instance_find(), osmo_ss7_instance_find_or_create(), osmo_ss7_pc_is_valid(), osmo_ss7_pointcode_print(), osmo_ss7_routing_key::pc, osmo_ss7_asp_peer::port, osmo_ss7_instance::primary_pc, osmo_ss7_asp::proto, osmo_ss7_asp::remote, osmo_ss7_asp::role, osmo_ss7_asp::role_set_by_vty, osmo_ss7_as::routing_key, osmo_ss7_instance::rtable_system, osmo_ss7_instance::sccp, osmo_ss7_as::simple_client_allocated, osmo_ss7_asp::simple_client_allocated, ss7_asp_peer_set_hosts(), ss7_asp_set_default_peer_hosts(), ss7_default_trans_proto_for_asp_proto(), ss7_route_create(), ss7_route_destroy(), ss7_route_table_find_route_by_dpc_mask(), ss7_xua_server_find2(), osmo_ss7_asp::trans_proto, and osmo_ss7_asp::trans_role_set_by_vty.

Referenced by osmo_sccp_simple_client().

## osmo_sccp_simple_server()

struct osmo_sccp_instance * osmo_sccp_simple_server | ( | void * | ctx,
|  | uint32_t | pc,
|  | enum osmo_ss7_asp_protocol | prot,
|  | int | local_port,
|  | const char * | local_ip )

References osmo_sccp_simple_server_on_ss7_id().

## osmo_sccp_simple_server_add_clnt()

struct osmo_sccp_instance * osmo_sccp_simple_server_add_clnt | ( | struct osmo_sccp_instance * | inst,
|  | enum osmo_ss7_asp_protocol | prot,
|  | const char * | name,
|  | uint32_t | pc,
|  | int | local_port,
|  | int | remote_port,
|  | const char * | remote_ip )

References osmo_ss7_asp::cfg, osmo_xua_server::cfg, osmo_ss7_asp_peer::host, osmo_ss7_asp_peer::host_cnt, osmo_ss7_asp::is_server, osmo_ss7_asp::local, osmo_xua_server::local, osmo_ss7_as_add_asp(), osmo_ss7_as_destroy(), osmo_ss7_as_find_or_create(), osmo_ss7_asp_destroy(), osmo_ss7_asp_find_or_create2(), osmo_ss7_asp_protocol_port(), osmo_ss7_asp_restart(), OSMO_SS7_ASP_ROLE_SG, osmo_ss7_asp::remote, osmo_ss7_asp::role, osmo_ss7_instance::rtable_system, osmo_ss7_instance::sccp, osmo_sccp_instance::ss7, ss7_asp_peer_add_host(), ss7_asp_peer_set_hosts(), ss7_default_trans_proto_for_asp_proto(), ss7_route_create(), ss7_route_destroy(), ss7_xua_server_find2(), osmo_ss7_asp::trans_proto, and osmo_xua_server::trans_proto.

## osmo_sccp_simple_server_on_ss7_id()

struct osmo_sccp_instance * osmo_sccp_simple_server_on_ss7_id | ( | void * | ctx,
|  | uint32_t | ss7_id,
|  | uint32_t | pc,
|  | enum osmo_ss7_asp_protocol | prot,
|  | int | local_port,
|  | const char * | local_ip )

References osmo_ss7_instance::cfg, osmo_ss7_asp_protocol_port(), osmo_ss7_ensure_sccp(), osmo_ss7_instance_destroy(), osmo_ss7_instance_find_or_create(), osmo_ss7_instance::primary_pc, osmo_ss7_instance::sccp, ss7_default_trans_proto_for_asp_proto(), ss7_xua_server_bind(), ss7_xua_server_create2(), ss7_xua_server_destroy(), and osmo_xua_server::trans_proto.

Referenced by osmo_sccp_simple_server().

## osmo_ss7_as_active()

bool osmo_ss7_as_active | ( | const struct osmo_ss7_as * | as | ) |

Determine if given AS is in the active state.

Parameters

  [in] | as | Application Server.

Returns
  true in case as is active; false otherwise.

References osmo_ss7_as::fi, and XUA_AS_S_ACTIVE.

Referenced by DEFUN().

## osmo_ss7_as_add_asp()

int osmo_ss7_as_add_asp | ( | struct osmo_ss7_as * | as,
|  | const char * | asp_name )

Add given ASP to given AS.

Parameters

  [in] | as | Application Server to which asp is added
  [in] | asp | Application Server Process to be added to as

Returns
  0 on success; negative in case of error

References osmo_ss7_as::asps, osmo_ss7_as::cfg, osmo_ss7_asp::cfg, osmo_ss7_asp::fi, osmo_ss7_as::inst, LOGPAS, osmo_ss7_asp::name, osmo_ss7_as_has_asp(), osmo_ss7_asp_find_by_name(), ss7_initialized, and XUA_ASP_E_AS_ASSIGNED.

Referenced by DEFUN_ATTR(), handle_rkey_reg(), ipa_asp_fsm_wait_id_resp(), osmo_sccp_simple_client_on_ss7_id(), and osmo_sccp_simple_server_add_clnt().

## osmo_ss7_as_del_asp()

int osmo_ss7_as_del_asp | ( | struct osmo_ss7_as * | as,
|  | const char * | asp_name )

Delete given ASP from given AS.

Parameters

  [in] | as | Application Server from which asp is deleted
  [in] | asp | Application Server Process to delete from as

Returns
  0 on success; negative in case of error

References osmo_ss7_as::asps, osmo_ss7_as::cfg, osmo_ss7_asp::cfg, osmo_ss7_as::inst, LOGPAS, osmo_ss7_asp::name, osmo_ss7_asp_find_by_name(), and ss7_initialized.

Referenced by DEFUN_ATTR(), and handle_rkey_dereg().

## osmo_ss7_as_destroy()

void osmo_ss7_as_destroy | ( | struct osmo_ss7_as * | as | ) |

Destroy given Application Server.

Parameters

  [in] | as | Application Server to destroy

References osmo_ss7_as::ctrg, osmo_ss7_as::fi, osmo_ss7_as::inst, osmo_ss7_as::list, LOGPAS, osmo_ss7_instance::rtable_system, ss7_initialized, and ss7_route_table_del_routes_by_as().

Referenced by DEFUN_ATTR(), handle_rkey_dereg(), handle_rkey_reg(), osmo_sccp_simple_client_on_ss7_id(), osmo_sccp_simple_server_add_clnt(), osmo_ss7_instance_destroy(), and xua_rkm_cleanup_dyn_as_for_asp().

## osmo_ss7_as_down()

bool osmo_ss7_as_down | ( | const struct osmo_ss7_as * | as | ) |

Determine if given AS is in the down state.

Parameters

  [in] | as | Application Server.

Returns
  true in case as is down; false otherwise.

References osmo_ss7_as::fi, and XUA_AS_S_DOWN.

Referenced by hmrt_message_for_routing().

## osmo_ss7_as_find_by_l_rk_id()

struct osmo_ss7_as * osmo_ss7_as_find_by_l_rk_id | ( | struct osmo_ss7_instance * | inst,
|  | uint32_t | l_rk_id )

Find Application Server by given local routing key ID.

Parameters

  [in] | inst | SS7 Instance on which we operate
  [in] | l_rk_id | Local Routing Key ID

Returns
  pointer to Application Server on success; NULL otherwise

References osmo_ss7_instance::as_list, osmo_ss7_as::cfg, osmo_ss7_as::inst, osmo_ss7_routing_key::l_rk_id, osmo_ss7_as::list, osmo_ss7_as::routing_key, and ss7_initialized.

Referenced by handle_reg_conf(), and ss7_find_free_l_rk_id().

## osmo_ss7_as_find_by_name()

struct osmo_ss7_as * osmo_ss7_as_find_by_name | ( | struct osmo_ss7_instance * | inst,
|  | const char * | name )

Find Application Server by given name.

Parameters

  [in] | inst | SS7 Instance on which we operate
  [in] | name | Name of AS

Returns
  pointer to Application Server on success; NULL otherwise

References osmo_ss7_instance::as_list, osmo_ss7_as::cfg, osmo_ss7_as::inst, osmo_ss7_as::list, osmo_ss7_as::name, and ss7_initialized.

Referenced by DEFUN_ATTR(), ipa_asp_fsm_wait_id_resp(), osmo_ss7_as_find_or_create(), and ss7_route_set_linkset().

## osmo_ss7_as_find_by_proto()

struct osmo_ss7_as * osmo_ss7_as_find_by_proto | ( | struct osmo_ss7_instance * | inst,
|  | enum osmo_ss7_asp_protocol | proto )

Find Application Server (AS) by given protocol.

Parameters

  [in] | inst | SS7 Instance on which we operate
  [in] | proto | Protocol identifier that must match

Returns
  pointer to AS on success; NULL otherwise If an AS has an ASP also matching the given protocol, that AS is preferred. If there are multiple matches, return the first matching AS.

References osmo_ss7_instance::as_list, osmo_ss7_as::cfg, osmo_ss7_as::inst, osmo_ss7_as::list, osmo_ss7_asp_find_by_proto(), osmo_ss7_as::proto, and ss7_initialized.

Referenced by osmo_sccp_simple_client_on_ss7_id().

## osmo_ss7_as_find_by_rctx()

struct osmo_ss7_as * osmo_ss7_as_find_by_rctx | ( | struct osmo_ss7_instance * | inst,
|  | uint32_t | rctx )

Find Application Server by given routing context.

Parameters

  [in] | inst | SS7 Instance on which we operate
  [in] | rctx | Routing Context

Returns
  pointer to Application Server on success; NULL otherwise

References osmo_ss7_instance::as_list, osmo_ss7_as::cfg, osmo_ss7_routing_key::context, osmo_ss7_as::inst, osmo_ss7_as::list, osmo_ss7_as::routing_key, and ss7_initialized.

Referenced by handle_rkey_dereg(), handle_rkey_reg(), osmo_ss7_find_free_rctx(), xua_asp_fsm_inactive(), and xua_find_as_for_asp().

## osmo_ss7_as_find_or_create()

struct osmo_ss7_as * osmo_ss7_as_find_or_create | ( | struct osmo_ss7_instance * | inst,
|  | const char * | name,
|  | enum osmo_ss7_asp_protocol | proto )

Find or Create Application Server.

Parameters

  [in] | inst | SS7 Instance on which we operate
  [in] | name | Name of Application Server
  [in] | proto | Protocol of Application Server

Returns
  pointer to Application Server on success; NULL otherwise

References osmo_ss7_as::cfg, osmo_ss7_as::inst, LOGPAS, osmo_ss7_as::name, osmo_ss7_as_find_by_name(), osmo_ss7_as::proto, ss7_as_alloc(), and ss7_initialized.

Referenced by DEFUN_ATTR(), handle_rkey_reg(), osmo_sccp_simple_client_on_ss7_id(), and osmo_sccp_simple_server_add_clnt().

## osmo_ss7_as_get_asp_protocol()

enum osmo_ss7_asp_protocol osmo_ss7_as_get_asp_protocol | ( | const struct osmo_ss7_as * | as | ) |

Get asp_protocol configuration of a given AS.

Parameters

  [in] | as | Application Server in which to look for asp_protocol

Returns
  The asp_protocol this AS is configured with

References osmo_ss7_as::cfg, and osmo_ss7_as::proto.

## osmo_ss7_as_has_asp()

bool osmo_ss7_as_has_asp | ( | const struct osmo_ss7_as * | as,
|  | const struct osmo_ss7_asp * | asp )

Determine if given AS contains ASP.

Parameters

  [in] | as | Application Server in which to look for asp
  [in] | asp | Application Server Process to look for in as

Returns
  true in case asp is part of as; false otherwise

References osmo_ss7_as::asps, osmo_ss7_as::cfg, and ss7_initialized.

Referenced by as_list_for_asp(), determine_traf_mode(), dispatch_to_all_as(), find_single_as_for_asp(), get_all_rctx_for_asp(), handle_rkey_dereg(), ipa_find_as_for_asp(), osmo_sccp_simple_client_on_ss7_id(), osmo_ss7_as_add_asp(), xua_asp_fsm_inactive(), xua_find_as_for_asp(), xua_msg_add_asp_rctx(), and xua_rkm_cleanup_dyn_as_for_asp().

## osmo_ss7_as_select_asp()

struct osmo_ss7_asp * osmo_ss7_as_select_asp | ( | struct osmo_ss7_as * | as | ) |

Select an AS to transmit a message, according to AS configuration and ASP availability.

Parameters

  [in] | as | Application Server.

Returns
  asp to send the message to, NULL if no possible asp found

This function returns NULL too if multiple ASPs would be selected, ie. AS is configured in broadcast mode and more than one ASP is configured.

References _NUM_OSMO_SS7_ASP_TMOD, osmo_ss7_as::cfg, osmo_ss7_as::fi, osmo_ss7_as::mode, OSMO_SS7_AS_TMOD_BCAST, OSMO_SS7_AS_TMOD_LOADSHARE, OSMO_SS7_AS_TMOD_OVERRIDE, OSMO_SS7_AS_TMOD_ROUNDROBIN, ss7_as_select_asp_broadcast(), ss7_as_select_asp_override(), and ss7_as_select_asp_roundrobin().

Referenced by xua_as_transmit_msg().

## osmo_ss7_as_tmode_compatible_xua()

bool osmo_ss7_as_tmode_compatible_xua | ( | struct osmo_ss7_as * | as,
|  | uint32_t | m3ua_tmt )

References osmo_ss7_as::cfg, M3UA_TMOD_BCAST, M3UA_TMOD_LOADSHARE, M3UA_TMOD_OVERRIDE, osmo_ss7_as::mode, osmo_ss7_as::mode_set_by_peer, osmo_ss7_as::mode_set_by_vty, OSMO_SS7_AS_TMOD_BCAST, OSMO_SS7_AS_TMOD_LOADSHARE, OSMO_SS7_AS_TMOD_OVERRIDE, and OSMO_SS7_AS_TMOD_ROUNDROBIN.

Referenced by handle_rkey_reg(), and xua_asp_fsm_inactive().

## osmo_ss7_as_traffic_mode_name()

const char * osmo_ss7_as_traffic_mode_name | ( | enum osmo_ss7_as_traffic_mode | mode | ) |

inline static

References osmo_ss7_as_traffic_mode_vals.

Referenced by DEFUN(), handle_rkey_reg(), write_one_as(), and xua_asp_fsm_inactive().

## osmo_ss7_asp_active()

bool osmo_ss7_asp_active | ( | const struct osmo_ss7_asp * | asp | ) |

References osmo_ss7_asp::fi, and XUA_ASP_S_ACTIVE.

Referenced by notify_any_other_active_asp_as_inactive(), ss7_as_select_asp_broadcast(), ss7_as_select_asp_override(), ss7_as_select_asp_roundrobin(), sua_snm_ssn_available(), xua_as_transmit_msg_broadcast(), xua_snm_pc_available(), xua_snm_scon(), and xua_snm_upu().

## osmo_ss7_asp_destroy()

void osmo_ss7_asp_destroy | ( | struct osmo_ss7_asp * | asp | ) |

References osmo_ss7_instance::as_list, osmo_ss7_as::asps, osmo_ss7_as::cfg, osmo_ss7_asp::client, osmo_ss7_asp::ctrg, osmo_ss7_asp::fi, osmo_ss7_asp::inst, osmo_ss7_as::list, osmo_ss7_asp::list, LOGPASP, osmo_ss7_asp::server, osmo_ss7_asp::siblings, ss7_initialized, and osmo_ss7_asp::xua_server.

Referenced by DEFUN_ATTR(), osmo_sccp_simple_client_on_ss7_id(), osmo_sccp_simple_server_add_clnt(), osmo_ss7_instance_destroy(), ss7_asp_xua_srv_conn_closed_cb(), and ss7_xua_server_destroy().

## osmo_ss7_asp_disconnect()

void osmo_ss7_asp_disconnect | ( | struct osmo_ss7_asp * | asp | ) |

References osmo_ss7_asp::client, osmo_ss7_asp::server, and xua_cli_close_and_reconnect().

Referenced by DEFUN(), ipa_asp_fsm_timer_cb(), ipa_asp_fsm_wait_id_resp(), and ipa_pong_timer_cb().

## osmo_ss7_asp_find()

struct osmo_ss7_asp * osmo_ss7_asp_find | ( | struct osmo_ss7_instance * | inst,
|  | const char * | name,
|  | uint16_t | remote_port,
|  | uint16_t | local_port,
|  | enum osmo_ss7_asp_protocol | proto )

References osmo_ss7_asp::inst, osmo_ss7_asp::name, osmo_ss7_asp_find2(), osmo_ss7_asp::proto, ss7_default_trans_proto_for_asp_proto(), and osmo_ss7_asp::trans_proto.

## osmo_ss7_asp_find2()

struct osmo_ss7_asp * osmo_ss7_asp_find2 | ( | struct osmo_ss7_instance * | inst,
|  | const char * | name,
|  | uint16_t | remote_port,
|  | uint16_t | local_port,
|  | int | trans_proto,
|  | enum osmo_ss7_asp_protocol | proto )

References osmo_ss7_asp::cfg, osmo_ss7_asp::inst, osmo_ss7_asp::local, osmo_ss7_asp::name, osmo_ss7_asp_find_by_name(), osmo_ss7_asp_peer::port, osmo_ss7_asp::proto, osmo_ss7_asp::remote, ss7_initialized, and osmo_ss7_asp::trans_proto.

Referenced by DEFUN_ATTR(), and osmo_ss7_asp_find().

## osmo_ss7_asp_find_by_name()

struct osmo_ss7_asp * osmo_ss7_asp_find_by_name | ( | struct osmo_ss7_instance * | inst,
|  | const char * | name )

References osmo_ss7_instance::asp_list, osmo_ss7_asp::cfg, osmo_ss7_asp::inst, osmo_ss7_asp::list, osmo_ss7_asp::name, and ss7_initialized.

Referenced by DEFUN(), DEFUN_ATTR(), osmo_ss7_as_add_asp(), osmo_ss7_as_del_asp(), osmo_ss7_asp_find2(), osmo_ss7_asp_find_or_create2(), show_asp(), show_asp_assoc_status(), and show_asp_remaddr().

## osmo_ss7_asp_find_by_proto()

struct osmo_ss7_asp * osmo_ss7_asp_find_by_proto | ( | struct osmo_ss7_as * | as,
|  | enum osmo_ss7_asp_protocol | proto )

Find an ASP that matches the given ASP protocol (xUA variant).

Parameters

  [in] | as | Application Server in which to look for asp
  [in] | proto | ASP protocol (xUA variant) to match

Returns
  SS7 ASP in case a matching one is found; NULL otherwise

References osmo_ss7_as::asps, osmo_ss7_as::cfg, osmo_ss7_asp::cfg, and osmo_ss7_asp::proto.

Referenced by osmo_sccp_simple_client_on_ss7_id(), and osmo_ss7_as_find_by_proto().

## osmo_ss7_asp_find_or_create()

struct osmo_ss7_asp * osmo_ss7_asp_find_or_create | ( | struct osmo_ss7_instance * | inst,
|  | const char * | name,
|  | uint16_t | remote_port,
|  | uint16_t | local_port,
|  | enum osmo_ss7_asp_protocol | proto )

References osmo_ss7_asp::inst, osmo_ss7_asp::name, osmo_ss7_asp_find_or_create2(), osmo_ss7_asp::proto, ss7_default_trans_proto_for_asp_proto(), and osmo_ss7_asp::trans_proto.

## osmo_ss7_asp_find_or_create2()

struct osmo_ss7_asp * osmo_ss7_asp_find_or_create2 | ( | struct osmo_ss7_instance * | inst,
|  | const char * | name,
|  | uint16_t | remote_port,
|  | uint16_t | local_port,
|  | int | trans_proto,
|  | enum osmo_ss7_asp_protocol | proto )

References osmo_ss7_asp::cfg, osmo_ss7_asp::inst, osmo_ss7_asp::local, osmo_ss7_asp::name, osmo_ss7_asp_find_by_name(), osmo_ss7_asp_peer::port, osmo_ss7_asp::proto, osmo_ss7_asp::remote, ss7_asp_alloc(), ss7_initialized, and osmo_ss7_asp::trans_proto.

Referenced by DEFUN_ATTR(), osmo_sccp_simple_client_on_ss7_id(), osmo_sccp_simple_server_add_clnt(), osmo_ss7_asp_find_or_create(), and xua_accept_cb().

## osmo_ss7_asp_get_log_subsys()

int osmo_ss7_asp_get_log_subsys | ( | const struct osmo_ss7_asp * | asp | ) |

Get the logging subsystem for a given ASP.

Used by generic code.

References osmo_ss7_asp::cfg, OSMO_SS7_ASP_PROT_M3UA, OSMO_SS7_ASP_PROT_SUA, and osmo_ss7_asp::proto.

Referenced by xua_find_as_for_asp(), xua_snm_rx_daud(), xua_snm_rx_dava(), xua_snm_rx_duna(), xua_snm_rx_dupu(), and xua_snm_rx_scon().

## osmo_ss7_asp_get_name()

const char * osmo_ss7_asp_get_name | ( | const struct osmo_ss7_asp * | asp | ) |

Get the name of a given ASP.

Parameters

  [in] | asp | The ASP for which the name is requested

Returns
  The name of the ASP, or NULL if not set

References osmo_ss7_asp::cfg, and osmo_ss7_asp::name.

## osmo_ss7_asp_get_proto()

enum osmo_ss7_asp_protocol osmo_ss7_asp_get_proto | ( | const struct osmo_ss7_asp * | asp | ) |

Get the proto of a given ASP.

Parameters

  [in] | asp | The ASP for which the proto is requested

Returns
  The proto of the ASP

References osmo_ss7_asp::cfg, and osmo_ss7_asp::proto.

## osmo_ss7_asp_get_trans_proto()

int osmo_ss7_asp_get_trans_proto | ( | const struct osmo_ss7_asp * | asp | ) |

Get the transport proto of a given ASP.

Parameters

  [in] | asp | The ASP for which the transport proto is requested

Returns
  The transport proto of the ASP (one of IPPROTO_*)

References osmo_ss7_asp::cfg, and osmo_ss7_asp::trans_proto.

## osmo_ss7_asp_protocol_name()

const char * osmo_ss7_asp_protocol_name | ( | enum osmo_ss7_asp_protocol | mode | ) |

inline static

References osmo_ss7_asp_protocol_vals.

Referenced by osmo_sccp_simple_client_on_ss7_id(), osmo_ss7_route_name(), ss7_asp_alloc(), ss7_xua_server_create2(), write_one_as(), and write_one_asp().

## osmo_ss7_asp_protocol_port()

int osmo_ss7_asp_protocol_port | ( | enum osmo_ss7_asp_protocol | prot | ) |

References prot2port.

Referenced by osmo_sccp_simple_client_on_ss7_id(), osmo_sccp_simple_server_add_clnt(), and osmo_sccp_simple_server_on_ss7_id().

## osmo_ss7_asp_restart()

int osmo_ss7_asp_restart | ( | struct osmo_ss7_asp * | asp | ) |

References osmo_ss7_asp::cfg, osmo_ss7_asp::client, osmo_ss7_asp::fi, osmo_ss7_asp_peer::host, osmo_ss7_asp_peer::host_cnt, ipa_cli_read_cb(), osmo_ss7_asp::is_server, osmo_ss7_asp::local, LOGPASP, m3ua_tcp_cli_read_cb(), osmo_ss7_asp::max_attempts_present, osmo_ss7_asp::max_attempts_value, osmo_ss7_asp::max_init_timeo_present, osmo_ss7_asp::max_init_timeo_value, osmo_ss7_asp::max_instreams_present, osmo_ss7_asp::max_instreams_value, osmo_ss7_asp::name, osmo_ss7_asp::num_ostreams_present, osmo_ss7_asp::num_ostreams_value, OSMO_SS7_ASP_PROT_IPA, OSMO_SS7_ASP_PROT_M3UA, osmo_ss7_asp_peer::port, osmo_ss7_asp::proto, osmo_ss7_asp::remote, osmo_ss7_asp::role, osmo_ss7_asp::sctp_init, osmo_ss7_asp::server, ss7_asp_peer_snprintf(), ss7_initialized, osmo_ss7_asp::trans_proto, xua_asp_fsm_start(), xua_cli_close_and_reconnect(), xua_cli_connect_cb(), xua_cli_read_cb(), and xua_tcp_segmentation_cb().

Referenced by osmo_sccp_simple_client_on_ss7_id(), osmo_sccp_simple_server_add_clnt(), osmo_ss7_vty_go_parent(), restart_asp(), and xua_accept_cb().

## osmo_ss7_asp_send()

int osmo_ss7_asp_send | ( | struct osmo_ss7_asp * | asp,
|  | struct msgb * | msg )

send a fully encoded msgb via a given ASP

Parameters

  [in] | asp | Application Server Process through which to send
  [in] | msg | message buffer to transmit. Ownership transferred.

Returns
  0 on success; negative in case of error

References osmo_ss7_asp::cfg, osmo_ss7_asp::client, osmo_ss7_asp::ctrg, osmo_ss7_asp::is_server, LOGPASP, M3UA_PPID, OSMO_SS7_ASP_PROT_IPA, OSMO_SS7_ASP_PROT_M3UA, OSMO_SS7_ASP_PROT_SUA, osmo_ss7_asp::proto, osmo_ss7_asp::server, SS7_ASP_CTR_PKT_TX_TOTAL, ss7_initialized, and SUA_PPID.

Referenced by as_notify_all_asp(), ipa_asp_fsm_wait_id_get(), m3ua_rx_rkm_dereg_req(), m3ua_rx_rkm_reg_req(), m3ua_tx_xua_asp(), notify_any_other_active_asp_as_inactive(), peer_send(), peer_send_error(), sua_tx_xua_asp(), xua_as_transmit_msg(), xua_as_transmit_msg_broadcast(), xua_rkm_send_dereg_req(), and xua_rkm_send_reg_req().

## osmo_ss7_asp_use_default_lm()

int osmo_ss7_asp_use_default_lm | ( | struct osmo_ss7_asp * | asp,
|  | int | log_level )

References lm_fsm_priv::asp, osmo_ss7_asp::cfg, default_layer_manager, osmo_ss7_asp::lm, osmo_ss7_asp::lm_priv, osmo_ss7_asp::name, and xua_default_lm_fsm.

Referenced by osmo_sccp_simple_client_on_ss7_id(), and restart_asp().

## osmo_ss7_ensure_sccp()

struct osmo_sccp_instance * osmo_ss7_ensure_sccp | ( | struct osmo_ss7_instance * | inst | ) |

Allocate an SCCP instance, if not present yet.

Returns
  inst->sccp.

References LOGSS7, osmo_sccp_instance_create(), and osmo_ss7_instance::sccp.

Referenced by DEFUN_ATTR(), DEFUN_ATTR(), osmo_sccp_simple_client_on_ss7_id(), osmo_sccp_simple_server_on_ss7_id(), ss7_asp_alloc(), and ss7_xua_server_create2().

## osmo_ss7_find_free_rctx()

int osmo_ss7_find_free_rctx | ( | struct osmo_ss7_instance * | inst | ) |

References next_rctx, and osmo_ss7_as_find_by_rctx().

Referenced by handle_rkey_reg().

## osmo_ss7_get_sccp()

struct osmo_sccp_instance * osmo_ss7_get_sccp | ( | const struct osmo_ss7_instance * | inst | ) |

Get the SCCP instance, if present.

Parameters

  [in] | inst | SS7 Instance on which we operate

Returns
  inst->sccp, may be NULL if no SCCP instance was created yet (see osmo_ss7_ensure_sccp()).

References osmo_ss7_instance::sccp.

## osmo_ss7_init()

int osmo_ss7_init | ( | void |  | ) |

References ipa_asp_fsm, sccp_scoc_fsm, ss7_initialized, xua_as_fsm, xua_asp_fsm, and xua_default_lm_fsm.

## osmo_ss7_instance_destroy()

void osmo_ss7_instance_destroy | ( | struct osmo_ss7_instance * | inst | ) |

Destroy a SS7 Instance.

Parameters

  [in] | inst | SS7 Instance to be destroyed

References osmo_ss7_instance::as_list, osmo_ss7_instance::asp_list, osmo_ss7_asp::inst, osmo_ss7_instance::linksets, osmo_ss7_asp::list, osmo_ss7_instance::list, LOGSS7, osmo_ss7_as_destroy(), osmo_ss7_asp_destroy(), ss7_initialized, and ss7_linkset_destroy().

Referenced by osmo_sccp_simple_client_on_ss7_id(), and osmo_sccp_simple_server_on_ss7_id().

## osmo_ss7_instance_find()

struct osmo_ss7_instance * osmo_ss7_instance_find | ( | uint32_t | id | ) |

Find a SS7 Instance with given ID.

Parameters

  [in] | id | ID for which to search

Returns
  osmo_ss7_instance on success; NULL on error

References osmo_ss7_instance::cfg, osmo_ss7_instance::id, osmo_ss7_instance::list, osmo_ss7_instances, and ss7_initialized.

Referenced by DEFUN(), DEFUN(), DEFUN(), DEFUN(), DEFUN(), DEFUN(), DEFUN(), DEFUN(), DEFUN(), osmo_sccp_simple_client_on_ss7_id(), osmo_ss7_instance_find_or_create(), show_asp(), show_asp_assoc_status(), and show_asp_remaddr().

## osmo_ss7_instance_find_or_create()

struct osmo_ss7_instance * osmo_ss7_instance_find_or_create | ( | void * | ctx,
|  | uint32_t | id )

Find or create a SS7 Instance.

Parameters

  [in] | ctx | talloc allocation context to use for allocations
  [in] | id | ID of SS7 Instance

Returns
  osmo_ss7_instance on success; NULL on error

References osmo_ss7_instance_find(), ss7_initialized, and ss7_instance_alloc().

Referenced by DEFUN_ATTR(), osmo_sccp_simple_client_on_ss7_id(), and osmo_sccp_simple_server_on_ss7_id().

## osmo_ss7_instance_get_id()

uint32_t osmo_ss7_instance_get_id | ( | const struct osmo_ss7_instance * | inst | ) |

References osmo_ss7_instance::cfg, osmo_ss7_instance::id, and osmo_ss7_asp::inst.

## osmo_ss7_instance_get_name()

const char * osmo_ss7_instance_get_name | ( | const struct osmo_ss7_instance * | inst | ) |

References osmo_ss7_instance::cfg, osmo_ss7_asp::inst, and osmo_ss7_instance::name.

## osmo_ss7_instance_get_pc_fmt()

const struct osmo_ss7_pc_fmt * osmo_ss7_instance_get_pc_fmt | ( | const struct osmo_ss7_instance * | inst | ) |

References osmo_ss7_instance::cfg, and osmo_ss7_instance::pc_fmt.

## osmo_ss7_instance_get_primary_pc()

uint32_t osmo_ss7_instance_get_primary_pc | ( | const struct osmo_ss7_instance * | inst | ) |

References osmo_ss7_instance::cfg, osmo_ss7_asp::inst, and osmo_ss7_instance::primary_pc.

## osmo_ss7_instance_set_pc_fmt()

int osmo_ss7_instance_set_pc_fmt | ( | struct osmo_ss7_instance * | inst,
|  | uint8_t | c0,
|  | uint8_t | c1,
|  | uint8_t | c2 )

Set the point code format used in given SS7 instance.

References osmo_ss7_instance::cfg, osmo_ss7_pc_fmt::component_len, osmo_ss7_asp::inst, LOGSS7, and osmo_ss7_instance::pc_fmt.

## osmo_ss7_instances_llist_entry()

struct osmo_ss7_instance * osmo_ss7_instances_llist_entry | ( | struct llist_head * | list | ) |

References osmo_ss7_instance::list.

## osmo_ss7_is_config_node()

int osmo_ss7_is_config_node | ( | struct vty * | vty,
|  | int | node )

## osmo_ss7_pc_is_local()

bool osmo_ss7_pc_is_local | ( | const struct osmo_ss7_instance * | inst,
|  | uint32_t | pc )

References osmo_ss7_instance::cfg, osmo_ss7_pc_is_valid(), osmo_ss7_instance::primary_pc, osmo_ss7_instance::secondary_pc, and ss7_initialized.

Referenced by m3ua_hmdc_rx_from_l2(), sccp_sclc_rx_scrc_rout_fail(), scrc_local_out_common(), and scrc_translate_node_9().

## osmo_ss7_pc_is_valid()

bool osmo_ss7_pc_is_valid | ( | uint32_t | pc | ) |

inline static

Referenced by DEFUN_ATTR(), DEFUN_ATTR(), osmo_sccp_simple_client_on_ss7_id(), osmo_ss7_pc_is_local(), osmo_ss7_pointcode_print_buf(), sccp_user_find(), show_user(), sua2sccp_tx_m3ua(), vty_show_connection(), and write_one_cs7().

## osmo_ss7_pc_normalize()

uint32_t osmo_ss7_pc_normalize | ( | const struct osmo_ss7_pc_fmt * | pc_fmt,
|  | uint32_t | pc )

References osmo_ss7_pc_width().

Referenced by ss7_route_alloc(), ss7_route_table_find_route_by_dpc(), and ss7_route_table_find_route_by_dpc_mask().

## osmo_ss7_pc_width()

uint8_t osmo_ss7_pc_width | ( | const struct osmo_ss7_pc_fmt * | pc_fmt | ) |

References osmo_ss7_pc_fmt::component_len.

Referenced by get_pc_comp_shift(), osmo_ss7_pc_normalize(), osmo_ss7_pointcode_parse_mask_or_len(), and osmo_ss7_route_print().

## osmo_ss7_pointcode_parse()

int osmo_ss7_pointcode_parse | ( | const struct osmo_ss7_instance * | inst,
|  | const char * | str )

References osmo_ss7_instance::cfg, osmo_ss7_pc_fmt::component_len, default_pc_fmt, gen_pc_fmtstr(), get_pc_comp_shift(), LOGSS7, num_pc_comp_exp(), and osmo_ss7_instance::pc_fmt.

Referenced by _rout_key(), DEFUN_ATTR(), DEFUN_ATTR(), DEFUN_ATTR(), DEFUN_ATTR(), DEFUN_ATTR(), DEFUN_ATTR(), and osmo_ss7_pointcode_parse_mask_or_len().

## osmo_ss7_pointcode_parse_mask_or_len()

int osmo_ss7_pointcode_parse_mask_or_len | ( | const struct osmo_ss7_instance * | inst,
|  | const char * | in )

References osmo_ss7_instance::cfg, default_pc_fmt, osmo_ss7_pc_width(), osmo_ss7_pointcode_parse(), and osmo_ss7_instance::pc_fmt.

Referenced by DEFUN_ATTR(), and DEFUN_ATTR().

## osmo_ss7_pointcode_print()

const char * osmo_ss7_pointcode_print | ( | const struct osmo_ss7_instance * | inst,
|  | uint32_t | pc )

References MAX_PC_STR_LEN, and osmo_ss7_pointcode_print_buf().

Referenced by DEFUN(), DEFUN(), format_affected_pcs_c(), handle_rkey_dereg(), handle_rkey_reg(), hmrt_message_for_routing(), ipa_del_route(), m3ua_hmdc_rx_from_l2(), m3ua_rx_xfer(), osmo_sccp_simple_client_on_ss7_id(), osmo_sccp_user_unbind(), osmo_ss7_route_name(), osmo_ss7_route_print(), sccp_addr_to_str_buf(), sccp_scoc_rx_inval_opc(), sccp_user_bind_pc(), scrc_node_6(), show_user(), ss7_route_destroy(), ss7_route_insert(), ss7_route_set_linkset(), vty_show_connection(), write_one_as(), write_one_cs7(), write_one_rtable(), write_sccp_addressbook(), and xua_snm_rx_dupu().

## osmo_ss7_pointcode_print2()

const char * osmo_ss7_pointcode_print2 | ( | const struct osmo_ss7_instance * | inst,
|  | uint32_t | pc )

References MAX_PC_STR_LEN, and osmo_ss7_pointcode_print_buf().

Referenced by m3ua_rx_xfer(), osmo_ss7_route_name(), osmo_ss7_route_print(), sccp_scoc_rx_inval_opc(), and write_one_rtable().

## osmo_ss7_pointcode_print_buf()

const char * osmo_ss7_pointcode_print_buf | ( | char * | buf,
|  | size_t | buf_len,
|  | const struct osmo_ss7_instance * | inst,
|  | uint32_t | pc )

References osmo_ss7_instance::cfg, default_pc_fmt, gen_pc_fmtstr(), len, num_pc_comp_exp(), osmo_ss7_pc_is_valid(), pc_comp_shift_and_mask(), and osmo_ss7_instance::pc_fmt.

Referenced by osmo_ss7_pointcode_print(), and osmo_ss7_pointcode_print2().

## osmo_ss7_register_rx_unknown_cb()

void osmo_ss7_register_rx_unknown_cb | ( | osmo_ss7_asp_rx_unknown_cb * | cb | ) |

Register a call-back function for unknown SCTP PPID / IPA Stream ID.

References g_osmo_ss7_asp_rx_unknown_cb.

## osmo_ss7_route_get_dest_as()

struct osmo_ss7_as * osmo_ss7_route_get_dest_as | ( | struct osmo_ss7_route * | rt | ) |

Get destination AS of route.

Parameters

  [in] | rt | Route entry holding the AS destination

Returns
  pointer to Application Server on success; NULL if rt doesn't route to an AS (i.e. routes to a linkset).

References osmo_ss7_route::as, and osmo_ss7_route::dest.

## osmo_ss7_route_lookup()

struct osmo_ss7_route * osmo_ss7_route_lookup | ( | struct osmo_ss7_instance * | inst,
|  | uint32_t | dpc )

Find a SS7 route for given destination point code in given SS7.

References dpc, osmo_ss7_instance::rtable_system, ss7_initialized, and ss7_route_table_find_route_by_dpc().

Referenced by gen_mtp_transfer_req_xua(), hmrt_message_for_routing(), and xua_snm_rx_daud().

## osmo_ss7_route_name()

const char * osmo_ss7_route_name | ( | struct osmo_ss7_route * | rt,
|  | bool | list_asps )

Return human readable representation of the route, in a static buffer.

This uses both osmo_ss7_pointcode_print() and osmo_ss7_pointcode_print2(), so pairing osmo_ss7_route_name() with osmo_ss7_pointcode_print() in the same printf statement is likely to conflict.

Parameters

  [in] | rt | The route information to print, or NULL.
  [in] | list_asps | If true, append info for all ASPs for the route's AS.

Returns
  A string constant or static buffer.

References APPEND, osmo_ss7_route::as, osmo_ss7_as::asps, osmo_ss7_as::cfg, osmo_ss7_asp::cfg, osmo_ss7_linkset::cfg, osmo_ss7_route::cfg, osmo_ss7_route::dest, osmo_ss7_route_table::inst, osmo_ss7_route::linkset, osmo_ss7_route::mask, osmo_ss7_as::name, osmo_ss7_asp::name, osmo_ss7_linkset::name, osmo_ss7_asp_protocol_name(), osmo_ss7_pointcode_print(), osmo_ss7_pointcode_print2(), osmo_ss7_route::pc, osmo_ss7_as::proto, osmo_ss7_route::rtable, and osmo_ss7_asp::sock_name.

Referenced by hmrt_message_for_routing().

## osmo_ss7_route_print()

const char * osmo_ss7_route_print | ( | const struct osmo_ss7_route * | rt | ) |

References osmo_ss7_instance::cfg, osmo_ss7_route::cfg, osmo_ss7_route_table::inst, osmo_ss7_route::mask, osmo_ss7_pc_width(), osmo_ss7_pointcode_print(), osmo_ss7_pointcode_print2(), osmo_ss7_route::pc, osmo_ss7_instance::pc_fmt, osmo_ss7_route::rtable, and u32_masklen().

Referenced by vty_dump_rtable().

## osmo_ss7_tmode_from_xua()

enum osmo_ss7_as_traffic_mode osmo_ss7_tmode_from_xua | ( | uint32_t | in | ) |

References M3UA_TMOD_BCAST, M3UA_TMOD_LOADSHARE, M3UA_TMOD_OVERRIDE, OSMO_SS7_AS_TMOD_BCAST, OSMO_SS7_AS_TMOD_LOADSHARE, and OSMO_SS7_AS_TMOD_OVERRIDE.

Referenced by handle_rkey_reg(), and xua_asp_fsm_inactive().

## osmo_ss7_tmode_to_xua()

int osmo_ss7_tmode_to_xua | ( | enum osmo_ss7_as_traffic_mode | tmod | ) |

References M3UA_TMOD_BCAST, M3UA_TMOD_LOADSHARE, M3UA_TMOD_OVERRIDE, OSMO_SS7_AS_TMOD_BCAST, OSMO_SS7_AS_TMOD_LOADSHARE, and OSMO_SS7_AS_TMOD_OVERRIDE.

Referenced by peer_send(), and xua_rkm_send_reg_req().

## osmo_ss7_user_create()

struct osmo_ss7_user * osmo_ss7_user_create | ( | struct osmo_ss7_instance * | inst,
|  | const char * | name )

References osmo_ss7_user::inst, and osmo_ss7_user::name.

Referenced by osmo_sccp_instance_create().

## osmo_ss7_user_destroy()

void osmo_ss7_user_destroy | ( | struct osmo_ss7_user * | user | ) |

Referenced by osmo_sccp_instance_destroy().

## osmo_ss7_user_get_instance()

struct osmo_ss7_instance * osmo_ss7_user_get_instance | ( | const struct osmo_ss7_user * | user | ) |

References osmo_ss7_user::inst, and osmo_ss7_instance::user.

## osmo_ss7_user_get_priv()

void * osmo_ss7_user_get_priv | ( | const struct osmo_ss7_user * | user | ) |

References osmo_ss7_user::priv, and osmo_ss7_instance::user.

## osmo_ss7_user_mtp_xfer_req()

int osmo_ss7_user_mtp_xfer_req | ( | struct osmo_ss7_instance * | inst,
|  | struct osmo_mtp_prim * | omp )

References m3ua_hmdc_rx_from_l2(), xua_msg::mtp, mtp_prim_to_m3ua(), MTP_SAP_USER, osmo_mtp_prim::oph, OSMO_MTP_PRIM_TRANSFER, osmo_mtp_prim::transfer, osmo_mtp_prim::u, and xua_msg_free().

Referenced by sua2sccp_tx_m3ua().

## osmo_ss7_user_register()

int osmo_ss7_user_register | ( | struct osmo_ss7_instance * | inst,
|  | uint8_t | service_ind,
|  | struct osmo_ss7_user * | user )

Register a MTP user for a given service indicator.

Parameters

  [in] | inst | SS7 instance for which we register the user
  [in] | service_ind | Service (ISUP, SCCP, ...)
  [in] | user | SS7 user (including primitive call-back)

Returns
  0 on success; negative on error

References osmo_ss7_user::inst, osmo_ss7_user::name, osmo_ss7_user::priv, and osmo_ss7_instance::user.

Referenced by osmo_sccp_instance_create().

## osmo_ss7_user_set_prim_cb()

void osmo_ss7_user_set_prim_cb | ( | struct osmo_ss7_user * | user,
|  | osmo_prim_cb | prim_cb )

References osmo_ss7_user::prim_cb, and osmo_ss7_instance::user.

Referenced by osmo_sccp_instance_create().

## osmo_ss7_user_set_priv()

void osmo_ss7_user_set_priv | ( | struct osmo_ss7_user * | user,
|  | void * | priv )

References osmo_ss7_user::priv, and osmo_ss7_instance::user.

Referenced by osmo_sccp_instance_create().

## osmo_ss7_user_unregister()

int osmo_ss7_user_unregister | ( | struct osmo_ss7_instance * | inst,
|  | uint8_t | service_ind,
|  | struct osmo_ss7_user * | user )

Unregister a MTP user for a given service indicator.

Parameters

  [in] | inst | SS7 instance for which we register the user
  [in] | service_ind | Service (ISUP, SCCP, ...)
  [in] | user | (optional) SS7 user. If present, we will not unregister other users

Returns
  0 on success; negative on error

References osmo_ss7_user::inst, and osmo_ss7_instance::user.

Referenced by osmo_sccp_instance_destroy().

## osmo_ss7_vty_go_parent()

int osmo_ss7_vty_go_parent | ( | struct vty * | vty | ) |

References osmo_sccp_addr_entry::inst, osmo_ss7_as::inst, osmo_ss7_asp::inst, osmo_ss7_route_table::inst, osmo_xua_server::inst, osmo_ss7_asp_restart(), ss7_asp_set_default_peer_hosts(), ss7_xua_server_bind(), and ss7_xua_server_set_default_local_hosts().

## osmo_ss7_vty_init_asp()

void osmo_ss7_vty_init_asp | ( | void * | ctx | ) |

References cs7_role, CS7_ROLE_ASP, and vty_init_shared().

## osmo_ss7_vty_init_sg()

void osmo_ss7_vty_init_sg | ( | void * | ctx | ) |

References cs7_role, CS7_ROLE_SG, rtable_node, vty_init_shared(), and xua_node.

## Variable Documentation

## osmo_ss7_as_traffic_mode_vals

struct value_string osmo_ss7_as_traffic_mode_vals[]

extern

Referenced by DEFUN_USRATTR(), and osmo_ss7_as_traffic_mode_name().

## osmo_ss7_asp_protocol_vals

struct value_string osmo_ss7_asp_protocol_vals[]

extern

Referenced by osmo_ss7_asp_protocol_name(), parse_asp_proto(), show_one_asp(), ss7_xua_server_bind(), ss7_xua_server_create2(), vty_dump_xua_server(), write_one_xua(), and xua_accept_cb().

## osmo_ss7_asp_role_names

const struct value_string osmo_ss7_asp_role_names[]

extern

Referenced by show_one_asp(), and write_one_asp().

## osmo_ss7_instances

struct llist_head osmo_ss7_instances

extern

Referenced by _show_cs7_xua(), LLIST_HEAD(), osmo_ss7_instance_find(), ss7_asp_find_by_socket_addr(), ss7_instance_alloc(), and write_all_cs7().